/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

#ifndef TERRAPRINT_CORE_INITILIZER
#define TERRAPRINT_CORE_INITILIZER

#include "Config.h"

#include <terralib/common/Singleton.h>

#include <string>
#include <vector>

class TerraPrintConfig;
class QTranslator;

namespace te
{
  namespace layout
  {
    class TELAYOUTEXPORT TerraPrintInitializer : public te::common::Singleton<TerraPrintInitializer>
    {

      friend class te::common::Singleton<TerraPrintInitializer>;

    protected:

      TerraPrintInitializer();

      ~TerraPrintInitializer();

    public:

      void initialize(const std::string& resourcePath);

      void finalize();

      const std::string& getResourcePath() const;

    private:

      std::string m_resourcePath;
      std::vector<QTranslator*> m_vecTranslators;

    };
  } //end of namespace layout
} //end of namespace te

#endif //TERRAPRINT_CORE_INITILIZER
